/* 
 * PAINTESSING
 * 
 * A little painting programm
 *
 * @name PAINTESSING
 * @author Sebastian Pape <sebastian.pape@zhdk.ch>
 * @version 0.9
 */

/*
* IMPORT
 */
import fullscreen.*; 
import codeanticode.protablet.*;

/*
* VARIABLES
 */
SoftFullScreen   fullScreen;
Cursor           _cursor;
boolean          paint;
PGraphics        _sketch;
Tablet           tablet;
PImage           _background = null;

/*
* SETUP 
 */
void setup() {
  size(screen.width, screen.height);
  background(153);
  smooth();
  frameRate(100);
  shapeMode(CENTER);
  
  // Fullscreen
  fullScreen = new SoftFullScreen(this); 
  //fullScreen.enter();
  
  // Brush
  _cursor = new Cursor();
  
  // Sketch
  _sketch = createGraphics(screen.width, screen.height, JAVA2D);
  _sketch.beginDraw();
  _sketch.endDraw();

  // tablet
  tablet = new Tablet(this); 
}

/*
* DRAW
 */
void draw() {
  background(255);
  
  if(_background != null) {
   image(_background, width*.5 - _background.width*.5, height*.5-_background.height*.5);
   fill(255, 255, 255, 100);
   rect(0, 0, width, height);
  }
  
  // Brush
  _cursor.draw();
  
  // Paint
  if(_cursor.paint) {
    paintOnSketch();
  }
  // show Sketch
  image(_sketch,0,0); 
}


/*
* PAINT ON SKETCH 
*/
void paintOnSketch() {
    // buffer zeichnen aktivieren
    _sketch.beginDraw();
    _sketch.noFill();
    _sketch.smooth();
    _sketch.stroke(0);
    _sketch.strokeWeight(6 * tablet.getPressure());
    _sketch.line(mouseX, mouseY, pmouseX, pmouseY);
    _sketch.endDraw();
}

/*
* LOAD BACKGROUND IMAGE
*/
public void loadBackgroundImage() {
  _background = loadImage(selectInput());
}

/*
* MOUSE PRESSED
*/
void mousePressed() {
   _cursor.mousePressed(mouseButton);
   if(_cursor.load) {
     loadBackgroundImage();
   } else if(_cursor.saveimage) {
     _sketch.save(selectOutput());
   }
}

/*
* MOUSE PRESSED
*/
void mouseReleased() {
    _cursor.mouseReleased(mouseButton);
}

